<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
	
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
	
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib prefix="portlet" uri="http://java.sun.com/portlet"%>
<%@ page import="javax.portlet.*" %>
<fmt:setBundle basename="osgibase" />
<portlet:defineObjects />


<div class="tundra">
<script type="text/javascript"
	src="/js/dojo/dojo.js" djConfig="parseOnLoad: true">	
</script>

<style type="text/css">
@import "/js/dojo/resources/dojo.css";
@import "/js/dijit/themes/tundra/tundra.css";
@import "/js/dojox/grid/enhanced/resources/EnhancedGrid_rtl.css";
@import "/js/dojox/grid/enhanced/resources/tundraEnhancedGrid.css";

</style>


<%
	//start/stop/uninstall action ajax url
    ResourceURL ajaxResourceURL = renderResponse.createResourceURL();
    ajaxResourceURL.setResourceID("bundlesAction");
%>
<%
	//install action ajax url
    ResourceURL ajaxResourceURL2 = renderResponse.createResourceURL();
    ajaxResourceURL2.setResourceID("installAction");
%>
<%
	//show single bundle
    ResourceURL ajaxResourceURL3 = renderResponse.createResourceURL();
    ajaxResourceURL3.setResourceID("showSingleBundle");
%>

<script type="text/javascript">
	dojo.require("dojo.parser");
	dojo.require("dojo.io.iframe"); 
	dojo.require("dojo.data.ItemFileWriteStore");
	dojo.require("dojox.grid.EnhancedGrid");
	dojo.require("dijit.form.Button");
	dojo.require("dojox.grid.enhanced.plugins.IndirectSelection");
	dojo.require("dojox.grid._Grid");
	dojo.require("dojox.grid.cells.dijit");
	dojo.require("dojox.grid.enhanced.plugins.Menu");
	dojo.require("dijit.layout.ContentPane");
    dojo.require("dijit.layout.TabContainer");

	dojo.addOnLoad(function() {
		dojo.connect(dijit.byId("grid1"), "onRowClick", grid1RowClick);
	});
	
	//function code
	function filterByAll(event){
        var id_fitlerStr = dojo.byId("id1").value;
        var sn_fitlerStr = dojo.byId("symbolicName1").value;
        var version_fitlerStr = dojo.byId("version1").value;
        var state_fitlerStr = dojo.byId("state1").value;
        dojo.getObject("grid1").filter({
            id: "*" + id_fitlerStr + "*",
            symbolicName: "*" + sn_fitlerStr + "*",
            version: "*" + version_fitlerStr + "*",
            state: "*" + state_fitlerStr + "*"          
        });       
		dojo.stopEvent(event);
    } 
    
    function inputFilterString(event){
        if (event.target.id == "symbolicName2") {
            event.target.focus();
        }
    }

    function actionPerform(actionName,loadHandle){
    	var actionJsonStr='{"action":'+actionName+',"items":[';
    	                                                  	
    	//get all selected lines
    	var selectedItems=dijit.byId("grid1").selection.getSelected();
    	if(selectedItems.length){
    		var i;var id;
    		for(i=0;i<selectedItems.length-1;i++){
    			if(selectedItems[i]!=null){
    				id=dijit.byId("grid1").store.getValue(selectedItems[i],"id");
    				actionJsonStr=actionJsonStr+'{"id":'+id+'},';
    			}
    		}

    		//The last item does not need a comma
    		id=dijit.byId("grid1").store.getValue(selectedItems[selectedItems.length-1],"id");
    		actionJsonStr=actionJsonStr+'{"id":'+id+'}'+']}';	
    		//alert(actionJsonStr);
    	
    		//ajax call to portlet's serveResource()
    		var postArgs={
    			url:"<%=ajaxResourceURL%>",
    			handleAs:"json",
    			content:{json:actionJsonStr},
    			load:loadHandle
    		};
    		dojo.xhrPost(postArgs);			
    	}	
    }

    //function for update items after (start/stop) action
    //only need to update the items' state value
    function  startOrStopUpdate(response, ioArgs){
		//update the items which done an action
		var updatedItems=response.items;			
		dojo.forEach(updatedItems,function(updatedItem){
			if(updatedItem!=null){
				dijit.byId("grid1").store.fetchItemByIdentity({
					identity:updatedItem.id,
					onItem:function(item){
						dijit.byId("grid1").store.setValue(item,"state",updatedItem.state);
					}
				});
			}
		});
	}

	//function for update items after uninstall action
	//only need to delete the uninstalled items
	function uninstallUpdate(response, ioArgs){
		var updatedItems=response.items;
		dojo.forEach(updatedItems,function(updatedItem){
			if(updatedItem!=null){
				dijit.byId("grid1").store.fetchItemByIdentity({
					identity:updatedItem.id,
					onItem:function(item){
						dijit.byId("grid1").store.deleteItem(item);
					}
				});
			}
		});
	}

	function grid1RowClick(e){
		var id=dijit.byId("grid1").getItem(e.rowIndex).id;
		//ajax call to portlet's serveResource()
		var postArgs={
			url:"<%=ajaxResourceURL3%>",
			handleAs:"text",
			content:{id:id},
			load:function(response, ioArgs){
				//dojo.byId("singleBundleDiv").innerHTML=response;
				var pane=new dijit.layout.ContentPane({
					title: "Bundle "+id,
					closable: "true",
					content: response
				});
				var tabs=dijit.byId("tabContainer");
				tabs.addChild(pane);
				tabs.selectChild(pane);
			}
		};
		dojo.xhrPost(postArgs);		
	}

	function installBundle(){
		dojo.io.iframe.send({
			url: "<%=ajaxResourceURL2%>",
			method: "post",
			handleAs: "text",
			form: dojo.byId("installForm"),
			load: function(response, ioArgs){
				var bundle=dojo.fromJson(response);
				var item=dijit.byId("grid1").store.newItem(bundle);
			}
		});
	}
</script> 

<script>
var jsonData=${GridJSONObject};
var jsonStore=new dojo.data.ItemFileWriteStore({data:jsonData});
</script>

<div>
<!-- Installing a bundle -->
<h1><fmt:message key="bundlesPortlet.installBundle" /></h1><br/>
<form id="installForm" enctype="multipart/form-data" method="POST">
	<input type="file"  name="bundleFile">&nbsp;
	<fmt:message key="osgi.bundle.install.startAfterInstalled" />-
	<input type="checkbox" dojoType="dijit.form.CheckBox" name="startAfterInstalled" value="yes" align="middle">&nbsp; 
	<fmt:message key="osgi.bundle.startLevel" />-
	<input type="text" dojoType="dijit.form.TextBox" style="width: 3em;" name="startLevel" size="4"> &nbsp;
	<button dojoType="dijit.form.Button"><fmt:message key="osgi.bundle.install.install"/>
		<script type="dojo/method" event="onClick" args="evt">
			installBundle();
		</script>
	</button>
</form>
</div><br/><br/>

<h1><fmt:message key="bundlesPortlet.installedBundle" /></h1><br/>
<div id="tabContainer" dojoType="dijit.layout.TabContainer" style="width: 100%; height: 100%;">
<div id="bundlesListPane" dojoType="dijit.layout.ContentPane" title="Bundles List">

<!-- Search -->
<div>
<label><b><fmt:message key="bundlesPortlet.fitlerBundlesBy" /></b></label><br/>
<label><fmt:message key="osgi.bundle.symbolicName" /></label>
<input type="text" jsid="symbolicName1" id="symbolicName1" dojoType="dijit.form.TextBox" style="width: 10em;" onKeyUp="filterByAll()">
<label><fmt:message key="osgi.bundle.id" /></label>
<input type="text" jsid="id1" id="id1" dojoType="dijit.form.TextBox" style="width: 5em;" onKeyUp="filterByAll()">
<label><fmt:message key="osgi.bundle.version" /></label>
<input type="text" jsid="version1" id="version1" dojoType="dijit.form.TextBox" style="width: 5em;" onKeyUp="filterByAll()">
<label><fmt:message key="osgi.bundle.state" /></label>
<select dojoType="dijit.form.ComboBox" id="state1" name="state1" onChange="filterByAll()" style="width: 10em;">
    <option>
        installed
    </option>
    <option>
        resolved
    </option>
	<option>
		starting
	</option>
	<option>
        active
    </option>
	<option>
		stopping
	</option>
</select>
<!-- input type="text" jsid="state1" id="state1" dojoType="dijit.form.TextBox" style="width: 5em;" onKeyUp="filterByAll()" -->
<button dojoType="dijit.form.Button"><fmt:message key="bundlesPortlet.clear" />
<script type="dojo/method" event="onClick" args="evt">
	dijit.byId("symbolicName1").attr("value","");
	dijit.byId("id1").attr("value","");
	dijit.byId("version1").attr("value","");
	dijit.byId("state1").attr("value","");
	filterByAll();
</script>
</button>
</div><br/>
<!--  Action -->
<div>
<button dojoType="dijit.form.Button" onclick='dijit.byId("grid1").rowSelectCell.toggleAllSelection(true)'>Select All</button>
<button dojoType="dijit.form.Button" onclick='dijit.byId("grid1").rowSelectCell.toggleAllSelection(false)'>Deselect All</button>
&nbsp;&nbsp;
<button dojoType="dijit.form.Button">Start
<script type="dojo/method" event="onClick" args="evt">
	actionPerform("start",startOrStopUpdate);
</script>
</button>
<button dojoType="dijit.form.Button">Stop
<script type="dojo/method" event="onClick" args="evt">
	actionPerform("stop",startOrStopUpdate);
</script>
</button>
<button dojoType="dijit.form.Button">Uninstall
<script type="dojo/method" event="onClick" args="evt">
	actionPerform("uninstall",uninstallUpdate);
</script>
</button>
</div>

<table jsid="grid1" id="grid1" dojoType="dojox.grid.EnhancedGrid"
	plugins="{indirectSelection: true}" store="jsonStore"
	query="{ id: '*' }" height="500px">
	<thead>
		<tr>
			<th field="id"><fmt:message key="osgi.bundle.id" /></th>
			<th field="symbolicName" width="50%"><fmt:message key="osgi.bundle.symbolicName" /></th>
			<th field="version"><fmt:message key="osgi.bundle.version" /></th>
			<th field="state"><fmt:message key="osgi.bundle.state" /></th>
		</tr>
	</thead>
</table>

</div><!-- end of ContentPane -->
</div><!-- end of TabContainer -->
<br/>
</div>
