<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib prefix="portlet" uri="http://java.sun.com/portlet"%>
<fmt:setBundle basename="osgibase" />
<portlet:defineObjects />

<!-- Installing a bundle -->
<form enctype="multipart/form-data" method="POST" action="<portlet:actionURL><portlet:param name='action' value='install'/></portlet:actionURL>">
<div>
<input type="file" name="bundleFile">
&nbsp;
<fmt:message key="osgi.bundle.install.startAfterInstalled"/>-<input align="middle" type="checkbox" name="startAfterInstalled" value="yes">
&nbsp;
<fmt:message key="osgi.bundle.startLevel"/>-<input type="text" name="startLevel" size="4">
&nbsp;
<input type="submit" value="<fmt:message key="osgi.bundle.install.install"/>">
</div>
</form>


<!-- List of all installed bundles -->
<table width="100%">
	<tr class="DarkBackground">
		<th align="right"><fmt:message key="osgi.bundle.id" /></th>
		<th align="left">&nbsp;<fmt:message
			key="osgi.bundle.symbolicName" /></th>
		<th align="left"><fmt:message key="osgi.bundle.version" /></th>
		<th align="left"><fmt:message key="osgi.bundle.state" /></th>
		<th align="center" colspan="2"><fmt:message
			key="osgi.bundle.actions" /></th>
	</tr>

	<c:set var="backgroundClass" value='LightBackground' />
	<c:forEach var="bundle" items="${Bundles}">
		<c:choose>
			<c:when test="${backgroundClass == 'MediumBackground'}">
				<c:set var="backgroundClass" value='LightBackground' />
			</c:when>
			<c:otherwise>
				<c:set var="backgroundClass" value='MediumBackground' />
			</c:otherwise>
		</c:choose>

		<tr>
			<!-- Bundle Id -->
			<td class="${backgroundClass}" align="right">${bundle.identifier}</td>

			<!-- Bundle Symbolic Name -->
			<td class="${backgroundClass}" ><a
				href="<portlet:renderURL><portlet:param name='id' value='${bundle.identifier}'/><portlet:param name='action' value='showSingleBundleInfo'/></portlet:renderURL>">
			&nbsp;${bundle.symbolicName} </a></td>

			<!-- Bundle Version -->
			<td class="${backgroundClass}">version</td>

			<!-- Bundle State -->
			<td class="${backgroundClass}">${bundle.state}</td>

			<!-- Bundle Start/Stop Actions -->
			<td align="center" class="${backgroundClass}" width="225"><c:if
				test="${bundle.state!='ACTIVE'}">
				<span> <a
					href="<portlet:actionURL><portlet:param name='id' value='${bundle.identifier}'/><portlet:param name='action' value='start'/></portlet:actionURL>"><fmt:message
					key="osgi.bundle.action.start" /></a> </span>
			</c:if> <c:if test="${bundle.state=='ACTIVE'}">
				<span> <a
					href="<portlet:actionURL><portlet:param name='id' value='${bundle.identifier}'/><portlet:param name='action' value='stop'/></portlet:actionURL>"><fmt:message
					key="osgi.bundle.action.stop" /></a> </span>
			</c:if> <span> <a
				href="<portlet:actionURL><portlet:param name='id' value='${bundle.identifier}'/><portlet:param name='action' value='uninstall'/></portlet:actionURL>"><fmt:message
				key="osgi.bundle.action.uninstall" /></a> </span></td>
		</tr>
	</c:forEach>
</table>